#version 430 core


layout(location = 0) in vec3 position;
layout(location = 1) in vec3 normal;
layout(location = 2) in vec2 uv;

out VertexData {
	vec3 position_world;
	vec3 normal_world;
	vec2 uv;
} vert;

uniform mat4 modelMatrix;
uniform mat4 viewProjMatrix;
uniform mat3 normalMatrix;

void main() {
	vert.normal_world = normal; //normalMatrix * 
	vert.uv = uv;
	vec4 position_world_ = vec4(position, 1); //modelMatrix * 
	vert.position_world = position_world_.xyz;
	gl_Position = viewProjMatrix * position_world_;
}