#version 330 core
layout (location = 0) in vec3 position;
layout (location = 1) in vec2 uv;
layout (location = 2) in vec4 color;
layout (location = 3) in mat4 offset;

out vec2 TexCoords;
out vec4 ParticleColor;

uniform mat4 viewProjectionMatrix;
uniform mat4 modelMatrix;

uniform vec3 cameraRight;
uniform vec3 cameraUp;

void main()
{
    float scale = 10.0f;
    TexCoords = uv;
    ParticleColor = color;
    vec3 rotatedPosition = vec3(cameraRight*position.x + cameraUp*position.y);
    vec4 position_world = modelMatrix * offset * vec4(rotatedPosition, 1.0);
    position_world = viewProjectionMatrix * position_world;
    gl_Position = position_world;
}